#include <ansi_c.h>   
#include "windows.h" 
#include <cvintwrk.h>
#include <userint.h>

#include "LB_aux.h" 

int	iExternalConnectionStatus = 0;

//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//\ NAME        =                 TIME_GetSystemClock
//\ DESCRIPTION = Retrieves the number of milliseconds that have elapsed since the system was started.
//\ PARAMETER   =
//\ DATE        = 2021
//\ AUTHOR      = COPROMEC Electronics / Mattia Guerra
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
TIME_Clock TIME_GetSystemClock(void)
{	
	return GetTickCount64();
}

//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//\ NAME        =                 NET_iPing                                
//\ DESCRIPTION =       NET_iPing("192.168.10.10");     NET_iPing("pc_Name");  if successful return 1              
//\ PARAMETER   =                                                         
//\ DATE        = 2016                                           
//\ AUTHOR      = Mattia Guerra                             
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
int NET_iPing(char szHost[], int iTimeout) 
{
	int iAvailable;
	
	if(strlen(szHost) <= 2)
		return -2;
	
	InetPing(szHost, &iAvailable, iTimeout);
	
	return (iAvailable > 0) ? _LB_NET_PING_SUCCESSFUL : _LB_NET_PING_UNSUCCESSFUL; 
}

//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//\ NAME        =                 	NET_iCheckExternalConnectionStatus                                
//\ DESCRIPTION =                        
//\ PARAMETER   =                                                         
//\ DATE        =                                          
//\ AUTHOR      = COPROMEC Electronics                             
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
int NET_iCheckExternalConnectionStatus(void)
{
	static int iNumIpAddr = -1, ip = 0;
	
	// al primo avvio calcola
	if(iNumIpAddr < 0)
		iNumIpAddr = sizeof(ipAddressExternalConn) / sizeof(ipAddressExternalConn[0]);
	
	iExternalConnectionStatus = NET_iPing(ipAddressExternalConn[ip], 2000);	
	if(iExternalConnectionStatus != _LB_NET_PING_SUCCESSFUL)
	{	
		if(++ip >= iNumIpAddr)
			ip = 0;		
	}
	
	 return iExternalConnectionStatus;
}

//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//\ NAME        =                 	NET_iGetExternalConnectionStatus                                
//\ DESCRIPTION =                        
//\ PARAMETER   =                                                         
//\ DATE        =                                          
//\ AUTHOR      = COPROMEC Electronics                             
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
int NET_iGetExternalConnectionStatus(void)
{
	 return iExternalConnectionStatus;
}

//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
// NAME        :                 TIME_iTimerExpired                       
// DESCRIPTION : Ritorna 1 se sono passati x milli secondi dalla volta precedente, il valore dell'ultima chiamata viene salvato su una variabile esterna                     
// PARAMETER   :                                                         
// DATE        : 2021                                    
// AUTHOR      : COPROMEC Electronics / Mattia Guerra                                   
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
int TIME_iTimerExpired(TIME_Clock refreshTimeMS, TIME_Clock *lastRefresh)
{
	int					iRefresh = -1;
	TIME_Clock	systemMS = 0;
		
	systemMS = TIME_GetSystemClock();
	
	if((systemMS - *lastRefresh) > refreshTimeMS)
	{
		*lastRefresh = systemMS;
		iRefresh = 1;
	}
	
	return iRefresh;
}		

