#include <ansi_c.h>
#include <windows.h>
#include <utility.h>
#include <stdio.h>

#include "Lb_CUDA.h"

#include "LB_def.h"
#include "LB_aux.h"
#include "analysis.h"

#include "menup.h"
			
int MENU_Handle;  
int iRun = 1;

int main (int argc, char *argv[])
{
	const int _ARRAY_SIZE = 5;//1024;
	
	int	iEvent;
	int	iHandle, iCtrl;
	int iRes;
	int iDevice;
	int i = 0;
	
	float *host_a, *host_b, *host_c;
	float *cuda_a = NULL, *cuda_b = NULL, *cuda_c = NULL;
	ULONGLONG t;
	
	cudaDeviceProp *prop;
		
	/////////////////////////////////////////////////////
	//CPU
	/////////////////////////////////////////////////////
	host_a = (float *) malloc(sizeof(float) * _ARRAY_SIZE);
	host_b = (float *) malloc(sizeof(float) * _ARRAY_SIZE);
	host_c = (float *) malloc(sizeof(float) * _ARRAY_SIZE);
	
	/*
	t = GetTickCount64();
	for(i = 0; i < _ARRAY_SIZE; i++)
	{
		c[i] = a[i] + b[i];
	}
	printf("Perf: %I64u", (GetTickCount64() - t));
	
	free(a);
	free(b);
	free(c);*/
	
	
	iRes = CUDA_ChooseDevice(&iDevice, "NVIDIA Quadro T1000 with Max-Q Design");
	iRes = CUDA_GetDeviceProperty(iDevice, &prop);
	iRes = CUDA_SetDevice(iDevice);
	
	
	for(i = 0; i < _ARRAY_SIZE; i++)
	{
		host_a[i] = (float)i;
		host_b[i] = (float)i;		
		host_c[i] = 0.1;		
	}
	/////////////////////////////////////////////////////
	//GPU
	////////////////////////////////////////////////////
	iRes = CUDA_Malloc((void**)&cuda_a, sizeof(float) * _ARRAY_SIZE);
	iRes = CUDA_Malloc((void**)&cuda_b, sizeof(float) * _ARRAY_SIZE);
	iRes = CUDA_Malloc((void**)&cuda_c, sizeof(float) * _ARRAY_SIZE);
	
	//iRes = CUDA_MemcpyToDevice(cuda_a, host_a, sizeof(float) * _ARRAY_SIZE); 
	//iRes = CUDA_MemcpyToDevice(cuda_b, host_b, sizeof(float) * _ARRAY_SIZE); 
	iRes = CUDA_MemcpyToDevice(cuda_c, host_c, sizeof(float) * _ARRAY_SIZE); 
	
	t = GetTickCount64();
	
	
	for(i = 0; i < _ARRAY_SIZE; i++)
	{	
		host_c[i] = 0.0;		
	}
	
	iRes = CUDA_Add(cuda_c, cuda_a, cuda_b, _ARRAY_SIZE);
	iRes = CUDA_DeviceSynchronize();
	iRes = CUDA_MemcpyToHost(cuda_c, host_c, sizeof(float) * _ARRAY_SIZE); 
	
	printf("Perf: %I64u\n", (GetTickCount64() - t));
	
	
	
	for(i = 0; i < _ARRAY_SIZE; i++)
	{
		printf("Res: %f\n", host_c[i]);
	}
	
	iRes = CUDA_FreeMemory(cuda_a);
	iRes = CUDA_FreeMemory(cuda_b);
	iRes = CUDA_FreeMemory(cuda_c);
	
	
	
	
	
	
	
	
	
	
	
	//Load panel
	MENU_Handle = LoadPanel(0, "UIR\\menup.uir", PANEL);
	DisplayPanel(MENU_Handle);
	while(iRun)
	{
		iEvent = GetUserEvent(0, &iHandle, &iCtrl);
			
		switch(iCtrl)
		{

			default:
				break;
		}
	}
	DiscardPanel(MENU_Handle);
}


int CVICALLBACK QuitPanel (int panel, int event, void *callbackData,
													 int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_CLOSE:
			iRun = 0;
			break;
	}
	return 0;
}